﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Seminar01
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        System.Windows.Threading.DispatcherTimer timer = new System.Windows.Threading.DispatcherTimer();

        public MainWindow()
        {
            InitializeComponent();

            timer.Tick += physics;
            timer.Interval = TimeSpan.FromSeconds(1.0/60);
        }

        private void radioButtonRed_Click(object sender, RoutedEventArgs e)
        {
            ball1.Fill = Brushes.Red;
        }

        private void radioButtonGreen_Click(object sender, RoutedEventArgs e)
        {
            ball1.Fill = Brushes.Green;
        }

        private void radioButtonBlue_Click(object sender, RoutedEventArgs e)
        {
            ball1.Fill = Brushes.Blue;
        }

        double vx1 = 155.0;
        double vy1 = 145.0;
        double vx2 = -160.0;
        double vy2 = -140.0;

        int numberOfCollisions = 0;
        bool wasBelowThresholdInLastFrame = false;

        void physics(object sender, EventArgs e)
        {
            double dt = timer.Interval.TotalSeconds;

            double x1 = Canvas.GetLeft(ball1);
            x1 += vx1 * dt;
            if (x1 + ball1.Width > theCanvas.ActualWidth)
            {
                vx1 = -vx1;
                x1 = theCanvas.ActualWidth - ball1.Width;
                System.Media.SystemSounds.Asterisk.Play();
            }
            else if (x1 < 0.0)
            {
                vx1 = -vx1;
                x1 = 0.0;
                System.Media.SystemSounds.Beep.Play();
            }

            Canvas.SetLeft(ball1, x1);

            double y1 = Canvas.GetTop(ball1);
            y1 += vy1 * dt;
            if (y1 + ball1.Height > theCanvas.ActualHeight)
            {
                vy1 = -vy1;
                y1 = theCanvas.ActualHeight - ball1.Height;
                System.Media.SystemSounds.Exclamation.Play();
            }
            else if (y1 < 0.0)
            {
                vy1 = -vy1;
                y1 = 0.0;
                System.Media.SystemSounds.Hand.Play();
            }

            Canvas.SetTop(ball1, y1);

            double x2 = Canvas.GetLeft(ball2);
            x2 += vx2 * dt;
            if (x2 + ball2.Width > theCanvas.ActualWidth)
            {
                vx2 = -vx2;
                x2 = theCanvas.ActualWidth - ball2.Width;
                System.Media.SystemSounds.Asterisk.Play();
            }
            else if (x2 < 0.0)
            {
                vx2 = -vx2;
                x2 = 0.0;
                System.Media.SystemSounds.Beep.Play();
            }

            Canvas.SetLeft(ball2, x2);

            double y2 = Canvas.GetTop(ball2);
            y2 += vy2 * dt;
            if (y2 + ball2.Height > theCanvas.ActualHeight)
            {
                vy2 = -vy2;
                y2 = theCanvas.ActualHeight - ball2.Height;
                System.Media.SystemSounds.Exclamation.Play();
            }
            else if (y2 < 0.0)
            {
                vy2 = -vy2;
                y2 = 0.0;
                System.Media.SystemSounds.Hand.Play();
            }

            Canvas.SetTop(ball2, y2);
            
            double dx = x2 - x1;
            double dy = y2 - y1;
            double distance = Math.Sqrt(dx * dx + dy * dy);
            double denominator = Math.Pow(distance, 3.0);
            const double c = -10000.0; // abstoßend
            vx1 += c * dx / denominator;
            vy1 += c * dy / denominator;
            vx2 += -c * dx / denominator;
            vy2 += -c * dy / denominator;

            const double collisionThreshold = 40.0;
            if (distance <= collisionThreshold)
            {
                if (!wasBelowThresholdInLastFrame)
                {
                    numberOfCollisions++;
                    labelScore.Content = numberOfCollisions.ToString();
                }
                wasBelowThresholdInLastFrame = true;
            }
            else
            {
                wasBelowThresholdInLastFrame = false;
            }

        }

        private void buttonStartStop_Click(object sender, RoutedEventArgs e)
        {
            timer.IsEnabled = !timer.IsEnabled;
        }
    }
}
